<template v-if="visible">
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
     <!-- <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.electricmeterrecord_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template> -->
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "@/api/device/electricmeterrecord";
  import {mapGetters} from "vuex";

  export default {
    props: {
     imei: "",
     visible: false
    },
    data() {
      return {
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          menu: false,
          height:'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          delBtn: false,
          addBtn: false,
          selection: true,
          dialogClickModal: false,
          column: [
            {
              label: "设备id",
              prop: "deviceId",
              hide: true,
              rules: [{
                required: true,
                message: "请输入设备id",
                trigger: "blur"
              }]
            },
            {
              label: "设备型号",
              prop: "deviceType",
              hide:true,
              rules: [{
                required: true,
                message: "请输入设备型号",
                trigger: "blur"
              }]
            },
            {
              label: "设备imei",
              prop: "imei",
              width: 200,
              rules: [{
                required: true,
                message: "请输入设备imei",
                trigger: "blur"
              }]
            },
            {
              label: "设备厂家",
              prop: "deviceFactory",
              width: 150,
              rules: [{
                required: true,
                message: "请输入设备厂家",
                trigger: "blur"
              }]
            },
            {
              label: "设备安装位置",
              prop: "installAddress",
              width: 150,
              overHidden: true,
              rules: [{
                required: true,
                message: "请输入设备安装位置",
                trigger: "blur"
              }]
            },
            {
              label: "设备状态：1-正常 2-告警 3-失联",
              hide: true,
              prop: "deviceStatus",
              rules: [{
                required: true,
                message: "请输入设备状态：1-正常 2-告警 3-失联",
                trigger: "blur"
              }]
            },
            {
              label: "抄表时间",
              prop: "readTime",
              width: 150,
              rules: [{
                required: true,
                message: "请输入抄表时间",
                trigger: "blur"
              }]
            },
            {
              label: "今日用量",
              prop: "dayValue",
              rules: [{
                required: true,
                message: "请输入今日用量",
                trigger: "blur"
              }]
            },
            {
              label: "月用量",
              prop: "monthValue",
              rules: [{
                required: true,
                message: "请输入月用量",
                trigger: "blur"
              }]
            },
            {
              label: "年用量",
              prop: "yearValue",
              rules: [{
                required: true,
                message: "请输入年用量",
                trigger: "blur"
              }]
            },
            {
              label: "总用量",
              prop: "totalValue",
              rules: [{
                required: true,
                message: "请输入总用量",
                trigger: "blur"
              }]
            },
          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.electricmeterrecord_add, false),
          viewBtn: this.vaildData(this.permission.electricmeterrecord_view, false),
          delBtn: this.vaildData(this.permission.electricmeterrecord_delete, false),
          editBtn: this.vaildData(this.permission.electricmeterrecord_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    // mounted() {
    //   this.onLoad()
    // },
    methods: {
      init(){
        this.page.currentPage =1;
        this.page.pageSize =10;
        this.onLoad(this.page)
      },
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        console.log("imei:"+this.imei)
        this.query.imei = this.imei;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
